#include <vector>
#include <cassert>
using namespace std;

class _Point {
public:
	int n0;
	int n1;
	_Point() {}
	_Point(int n0, int n1);
};

_Point::_Point(int n0, int n1) {
	this->n0 = n0;
	this->n1 = n1;
}

class _Block {
public:
	_Block();
	~_Block();

	void add(int n0, int n1);
	_Point& get(int i) { return points[i]; }
	void recycle() { size = 0; }
	bool is_full() { return size == max_block; }
	bool is_empty() { return size == 0; }

	_Point* points;
	int size;

	static int* root_sum;
	static int max_block;
};

class _BlockSet
{
public:
	_BlockSet() {}
	~_BlockSet() {}

	_Block *block;
	_Block nextBlock0;
};

class _BlockStack
{
public:
	_BlockStack() {}
	~_BlockStack();

	_BlockSet* get(int i);

	vector<_BlockSet *> items;
};

int _Block::max_block = 512;
int* _Block::root_sum;

_Block::_Block() {
	points = new _Point[max_block];
	size = 0;
}

_Block::~_Block() {
	delete [] points;
}

void _Block::add(int n0, int n1) {
	assert(size < max_block);
	points[size].n0 = n0;
	points[size].n1 = n1;
	size++;
}


_BlockStack::~_BlockStack() {
	for (int i = 0; i < items.size(); i++) {
		delete items[i];
	}
}

_BlockSet* _BlockStack::get(int i) {
	while (i >= items.size()) {
		items.push_back(new _BlockSet());
	}
	return items[i];
}
