#include "block.h"
class _BlockStack ;
/**********************************************************/
/* This code is for PLDI-15 Artifact Evaluation only      */
/* and will be released with further copyright information*/
/* File: Basic sequential recursive version of fibonacci  */
/**********************************************************/
#include <stdio.h>
#include <stdlib.h>
int _expandSize = 16;
int _minBlockSize = 16;
void fib_block_bf(int *sum,class _BlockStack *_stack,int _depth);
void fib_block_df0(int *sum,class _BlockStack *_stack,int _depth);
void fib_block_df1(int *sum,class _BlockStack *_stack,int _depth);
void fib(int n0,int n1,int *sum);

void fib_block_bf(int *sum,class _BlockStack *_stack,int _depth)
{
  class _BlockSet *_set = _stack ->  get (_depth);
  class _Block *_block = _set -> block;
  class _Block *_nextBlock0 = &_set -> _BlockSet::nextBlock0;
  _nextBlock0 ->  recycle ();
  for (int _bi = 0; _bi < _block -> _Block::size; ++_bi) {
    class _Point &_point = _block ->  get (_bi);
    int n0 = _point._Point::n0;
    int n1 = _point._Point::n1;
    if ((n0 == 1) || (n0 == 0)) {
       *sum += 1;
    }
    else 
      _nextBlock0 ->  add ((n0 - 1),(n0 - 2));
    if ((n1 == 1) || (n1 == 0)) {
       *sum += 1;
    }
    else 
      _nextBlock0 ->  add ((n1 - 1),(n1 - 2));
  }
  if (_nextBlock0 -> _Block::size > 0) {
    _stack ->  get (_depth + 1) -> _BlockSet::block = _nextBlock0;
    if (_nextBlock0 -> _Block::size <= _expandSize / _minBlockSize) {
      fib_block_bf(sum,_stack,_depth + 1);
    }
    else {
      fib_block_df0(sum,_stack,_depth + 1);
      fib_block_df1(sum,_stack,_depth + 1);
    }
  }
}

void fib_block_df0(int *sum,class _BlockStack *_stack,int _depth)
{
  class _BlockSet *_set = _stack ->  get (_depth);
  class _Block *_block = _set -> block;
  class _Block *_nextBlock0 = &_set -> _BlockSet::nextBlock0;
  _nextBlock0 ->  recycle ();
  for (int _bi = 0; _bi < _block -> _Block::size; ++_bi) {
    class _Point &_point = _block ->  get (_bi);
    int n0 = _point._Point::n0;
    int n1 = _point._Point::n1;
    if ((n0 == 1) || (n0 == 0)) {
       *sum += 1;
    }
    else 
      _nextBlock0 ->  add ((n0 - 1),(n0 - 2));
  }
  if (_nextBlock0 -> _Block::size > 0) {
    _stack ->  get (_depth + 1) -> _BlockSet::block = _nextBlock0;
    if (_nextBlock0 -> _Block::size <= _expandSize / _minBlockSize) {
      fib_block_bf(sum,_stack,_depth + 1);
    }
    else {
      fib_block_df0(sum,_stack,_depth + 1);
      fib_block_df1(sum,_stack,_depth + 1);
    }
  }
}

void fib_block_df1(int *sum,class _BlockStack *_stack,int _depth)
{
  class _BlockSet *_set = _stack ->  get (_depth);
  class _Block *_block = _set -> block;
  class _Block *_nextBlock0 = &_set -> _BlockSet::nextBlock0;
  _nextBlock0 ->  recycle ();
  for (int _bi = 0; _bi < _block -> _Block::size; ++_bi) {
    class _Point &_point = _block ->  get (_bi);
    int n0 = _point._Point::n0;
    int n1 = _point._Point::n1;
    if ((n1 == 1) || (n1 == 0)) {
       *sum += 1;
    }
    else 
      _nextBlock0 ->  add ((n1 - 1),(n1 - 2));
  }
  if (_nextBlock0 -> _Block::size > 0) {
    _stack ->  get (_depth + 1) -> _BlockSet::block = _nextBlock0;
    if (_nextBlock0 -> _Block::size <= _expandSize / _minBlockSize) {
      fib_block_bf(sum,_stack,_depth + 1);
    }
    else {
      fib_block_df0(sum,_stack,_depth + 1);
      fib_block_df1(sum,_stack,_depth + 1);
    }
  }
}

void fib(int n0,int n1,int *sum)
{
  if ((n0 == 1) || (n0 == 0)) {
     *sum += 1;
  }
  else {
    fib((n0 - 1),(n0 - 2),sum);
  }
  if ((n1 == 1) || (n1 == 0)) {
     *sum += 1;
  }
  else {
    fib((n1 - 1),(n1 - 2),sum);
  }
}
/*Benchmark entrance called by harness*/

int main(int argc,char **argv)
{
  if (argc < 2) {
    printf("number of fibonacci required\n");
    return 1;
  }
  if (argc > 3) {
    printf("extra arguments being ignored\n");
    return 1;
  }
  int n = atoi(argv[1]);
  if (n < 2) {
    printf("Please input a number greater than 1\n");
    return 1;
  }
  _minBlockSize = 2;
  printf("running fibonacci %d\n",n);
  if (argc > 2) {
    _expandSize = atoi(argv[2]);
    printf("_expandSize is: %d\n",_expandSize);
  }
  int n0 = (n - 1);
  int n1 = (n - 2);
  int sum = 0;
  
#pragma recursionCallEntry
  _Block::max_block = _expandSize;
  class _BlockStack _stack;
  class _Block _block;
  _block. add (n0,n1);
  int _depth = 0;
  _stack. get (_depth) -> block = &_block;
  if (_block._Block::size <= _expandSize / _minBlockSize) {
    fib_block_bf(&sum,&_stack,_depth);
  }
  else {
    fib_block_df0(&sum,&_stack,_depth);
    fib_block_df1(&sum,&_stack,_depth);
  }
  printf("This is the result: %d\n",sum);
  return 0;
}
