#include <vector>
#include <cassert>
using namespace std;

class _Point {
public:
	char* c;
	_Point() {}
	_Point(char* c);
};

_Point::_Point(char* c) {
	this->c = c;
}

class _Block {
public:
	_Block();
	~_Block();

	void add(char* c);
	_Point& get(int i) { return points[i]; }
	void recycle() { size = 0; }
	bool is_full() { return size == max_block; }
	bool is_empty() { return size == 0; }

	_Point* points;
	int size;

	static char root_nodeId;
	static int root_numNode;
	static int root_numColor;
	static int* root_numSolution;
	static int max_block;
};

class _BlockSet
{
public:
	_BlockSet() {}
	~_BlockSet() {}

	_Block *block;
	_Block nextBlock0;
};

class _BlockStack
{
public:
	_BlockStack() {}
	~_BlockStack();

	_BlockSet* get(int i);

	vector<_BlockSet *> items;
};

int _Block::max_block = 512;
char _Block::root_nodeId;
int _Block::root_numNode;
int _Block::root_numColor;
int* _Block::root_numSolution;

_Block::_Block() {
	points = new _Point[max_block];
	size = 0;
}

_Block::~_Block() {
	delete [] points;
}

void _Block::add(char* c) {
	assert(size < max_block);
	points[size].c = c;
	size++;
}


_BlockStack::~_BlockStack() {
	for (int i = 0; i < items.size(); i++) {
		delete items[i];
	}
}

_BlockSet* _BlockStack::get(int i) {
	while (i >= items.size()) {
		items.push_back(new _BlockSet());
	}
	return items[i];
}
