#include "block.h"
class _BlockStack ;
/**********************************************************/
/* This code is for PLDI-15 Artifact Evaluation only      */
/* and will be released with further copyright information*/
/* File: Basic sequential recursive version of graphcoloring*/
/**********************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <string.h>
#define DATAFILE "DATA/data32N64E.col"
//#define DATAFILE "DATA/data38N64E.col"
//#define DATAFILE "DATA/data36N64E.col"
int _expandSize = 16;
int _minBlockSize = 16;
//Graph Pointer, in adjacent matrix format
char *adjacentNodes;

void readEdge(FILE *data,int numEdge,int numNode,int *edge)
{
  char tmp[50UL];
  for (int i = 0; i < numEdge; i++) {
    fscanf(data,"%s %d %d\n",tmp,(edge + (i * 2)),(edge + ((i * 2) + 1)));
    edge[i * 2]--;
    edge[(i * 2) + 1]--;
  }
}

void init_graph(int numNode,int numEdge,int *edge)
{
  adjacentNodes = ((char *)(malloc(((numNode * numNode) * sizeof(char )))));
  memset(adjacentNodes,0,((numNode * numNode) * sizeof(char )));
  for (int t = 0; t < numEdge; t++) {
    adjacentNodes[(edge[t * 2] * numNode) + edge[(t * 2) + 1]] = (adjacentNodes[(edge[(t * 2) + 1] * numNode) + edge[t * 2]] = 1);
  }
}

void print_graph(int numNode)
{
  printf("This is the graph: \n");
  for (int i = 0; i < numNode; ++i) {
    for (int j = 0; j < numNode; ++j) {
      printf("%d ",adjacentNodes[(i * numNode) + j]);
    }
    printf("\n");
  }
}

bool ok(int nodeId,int ci,char *c,int numNode)
{
  for (int k = 0; k < nodeId; ++k) {
    for (int i = (k + 1); i <= nodeId; ++i) {
      if ((adjacentNodes[(k * numNode) + i] == 1) && (c[k] == c[i])) {
        return false;
      }
    }
  }
  return true;
}

void print_solution(char *c,int numNode)
{
  printf("This is a solution: \n");
  for (int i = 0; i < numNode; ++i) {
    printf("%d ",c[i]);
  }
  printf("\n");
}
void color_block_bf(char nodeId,int numNode,int numColor,int *numSolution,_BlockStack *_stack,int _depth);
void color_block_df(char nodeId,int numNode,int numColor,int *numSolution,_BlockStack *_stack,int _depth,int ci);
void color(char nodeId,int numNode,int numColor,char *c,int *numSolution);
// pseudo tail recursive

void color(char nodeId,int numNode,int numColor,char *c,int *numSolution)
{
//For current node, try color from color id = 1
  for (int ci = 1; ci <= numColor; ++ci) {{
      c[nodeId] = ci;
      if (!ok(nodeId,ci,c,numNode)) 
        continue; 
      if (nodeId == (numNode - 1)) {
         *numSolution += 1;
        continue; 
      }
      char *b = (char *)(__builtin_alloca((numNode * sizeof(char ))));
      memcpy(b,c,(numNode * sizeof(char )));
      color((nodeId + 1),numNode,numColor,b,numSolution);
    }
  }
}

int main(int argc,char **argv)
{
  int numSolution = 0;
  if ((argc != 2) && (argc != 3)) {
    printf("Usage: ./graphcoloring [color numbers]\n");
    exit(0);
  }
  int numColor = atoi(argv[1]);
  _minBlockSize = numColor;
  printf("Start %d-Color Process...\n",numColor);
  if (argc > 2) {
    _expandSize = atoi(argv[2]);
    printf("_expandSize is: %d\n",_expandSize);
  }
/*******Read input data**************/
  int numNode;
  int numEdge;
  int *edge;
  FILE *data;
  char tmp1[50UL];
  char tmp2[50UL];
  data = fopen("DATA/data32N64E.col","r");
  if (data == 0L) {
    printf("Open data file failed\n");
    exit(0);
  }
  fscanf(data,"%s %s %d %d\n",tmp1,tmp2,&numNode,&numEdge);
  printf("numNode = %d, numEdge =%d\n",numNode,numEdge);
  edge = ((int *)(malloc(((numEdge * sizeof(int )) * 2))));
  readEdge(data,numEdge,numNode,edge);
  fclose(data);
/********Read input data end**********/
//Construct adjacent Matrix
  init_graph(numNode,numEdge,edge);
//Color auxiliary array
  char *c = (char *)(__builtin_alloca((numNode * sizeof(char ))));
//Start coloring...
  
#pragma recursionCallEntry
  color(0,numNode,numColor,c,&numSolution);
  printf("This is the number of possible solutions: %d\n",numSolution);
  free(edge);
  free(adjacentNodes);
  return 0;
}
