#include <vector>
#include <cassert>
using namespace std;

struct item ;
class _Point {
public:
	int c0;
	int v0;
	int c1;
	int v1;
	_Point() {}
	_Point(int c0, int v0, int c1, int v1);
};

_Point::_Point(int c0, int v0, int c1, int v1) {
	this->c0 = c0;
	this->v0 = v0;
	this->c1 = c1;
	this->v1 = v1;
}

class _Block {
public:
	_Block();
	~_Block();

	void add(int c0, int v0, int c1, int v1);
	_Point& get(int i) { return points[i]; }
	void recycle() { size = 0; }
	bool is_full() { return size == max_block; }
	bool is_empty() { return size == 0; }

	_Point* points;
	int size;

	static item* root_e;
	static int root_n;
	static int* root_max_ret;
	static int max_block;
};

class _BlockSet
{
public:
	_BlockSet() {}
	~_BlockSet() {}

	_Block *block;
	_Block nextBlock0;
};

class _BlockStack
{
public:
	_BlockStack() {}
	~_BlockStack();

	_BlockSet* get(int i);

	vector<_BlockSet *> items;
};

int _Block::max_block = 512;
item* _Block::root_e;
int _Block::root_n;
int* _Block::root_max_ret;

_Block::_Block() {
	points = new _Point[max_block];
	size = 0;
}

_Block::~_Block() {
	delete [] points;
}

void _Block::add(int c0, int v0, int c1, int v1) {
	assert(size < max_block);
	points[size].c0 = c0;
	points[size].v0 = v0;
	points[size].c1 = c1;
	points[size].v1 = v1;
	size++;
}


_BlockStack::~_BlockStack() {
	for (int i = 0; i < items.size(); i++) {
		delete items[i];
	}
}

_BlockSet* _BlockStack::get(int i) {
	while (i >= items.size()) {
		items.push_back(new _BlockSet());
	}
	return items[i];
}
