#include "block.h"
class _BlockStack ;
/**********************************************************/
/* This code is for PLDI-15 Artifact Evaluation only      */
/* and will be released with further copyright information*/
/* File: Basic sequential recursive version of minmax  */
/**********************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
int g_ncheck = 0;
#define BOARD_SIZE 4
#define POS_SIZE 17//Corresponding to BOARD_SIZE
#define NOMOVE 100
int _expandSize = 16;
int _minBlockSize = 16;
int pos_weights[17UL] = {};

void init_board(char *pboard)
{
  int i;
  for (i = 1; i <= 4 * 4; i++) 
    pboard[i] = '_';
}

void print_board(char *pboard)
{
  int i;
  for (i = 1; i <= 4 * 4; i++) {
    printf("%c ",pboard[i]);
    if ((i % 4) == 0) 
      printf("\n");
  }
}

void print_weights()
{
  int count = 1;
  printf("\n*******Weighted array*****\n");
  while(count < 17){
    printf("%d\t",pos_weights[count++]);
  }
  printf("\n");
}

int check_win(char *pboard)
{
  int ret = 0;
  if (((((((((((((pboard[1] == 'X') && (pboard[2] == 'X')) && (pboard[3] == 'X')) && (pboard[4] == 'X')) || ((((pboard[5] == 'X') && (pboard[6] == 'X')) && (pboard[7] == 'X')) && (pboard[8] == 'X'))) || ((((pboard[9] == 'X') && (pboard[10] == 'X')) && (pboard[11] == 'X')) && (pboard[12] == 'X'))) || ((((pboard[13] == 'X') && (pboard[14] == 'X')) && (pboard[15] == 'X')) && (pboard[16] == 'X'))) || ((((pboard[1] == 'X') && (pboard[5] == 'X')) && (pboard[9] == 'X')) && (pboard[13] == 'X'))) || ((((pboard[2] == 'X') && (pboard[6] == 'X')) && (pboard[10] == 'X')) && (pboard[14] == 'X'))) || ((((pboard[3] == 'X') && (pboard[7] == 'X')) && (pboard[11] == 'X')) && (pboard[15] == 'X'))) || ((((pboard[4] == 'X') && (pboard[8] == 'X')) && (pboard[12] == 'X')) && (pboard[16] == 'X'))) || ((((pboard[1] == 'X') && (pboard[6] == 'X')) && (pboard[11] == 'X')) && (pboard[16] == 'X'))) || ((((pboard[4] == 'X') && (pboard[7] == 'X')) && (pboard[10] == 'X')) && (pboard[13] == 'X'))) {
    ret = 1;
  }
  else if (((((((((((((pboard[1] == 'O') && (pboard[2] == 'O')) && (pboard[3] == 'O')) && (pboard[4] == 'O')) || ((((pboard[5] == 'O') && (pboard[6] == 'O')) && (pboard[7] == 'O')) && (pboard[8] == 'O'))) || ((((pboard[9] == 'O') && (pboard[10] == 'O')) && (pboard[11] == 'O')) && (pboard[12] == 'O'))) || ((((pboard[13] == 'O') && (pboard[14] == 'O')) && (pboard[15] == 'O')) && (pboard[16] == 'O'))) || ((((pboard[1] == 'O') && (pboard[5] == 'O')) && (pboard[9] == 'O')) && (pboard[13] == 'O'))) || ((((pboard[2] == 'O') && (pboard[6] == 'O')) && (pboard[10] == 'O')) && (pboard[14] == 'O'))) || ((((pboard[3] == 'O') && (pboard[7] == 'O')) && (pboard[11] == 'O')) && (pboard[15] == 'O'))) || ((((pboard[4] == 'O') && (pboard[8] == 'O')) && (pboard[12] == 'O')) && (pboard[16] == 'O'))) || ((((pboard[1] == 'O') && (pboard[6] == 'O')) && (pboard[11] == 'O')) && (pboard[16] == 'O'))) || ((((pboard[4] == 'O') && (pboard[7] == 'O')) && (pboard[10] == 'O')) && (pboard[13] == 'O'))) {
    ret = -1;
  }
  return ret;
}

int check_draw(char *pboard)
{
  int win;
  int ret = 0;
  win = check_win(pboard);
  if (((((((((((((((((win == 0) && (pboard[1] != '_')) && (pboard[2] != '_')) && (pboard[3] != '_')) && (pboard[4] != '_')) && (pboard[5] != '_')) && (pboard[6] != '_')) && (pboard[7] != '_')) && (pboard[8] != '_')) && (pboard[9] != '_')) && (pboard[10] != '_')) && (pboard[11] != '_')) && (pboard[12] != '_')) && (pboard[13] != '_')) && (pboard[14] != '_')) && (pboard[15] != '_')) && (pboard[16] != '_')) {
    ret = 1;
  }
  return ret;
}

int evaluationFunction(char *pboard,int *leaf_val,int depth,int player)
{
  int chk_endgame = 0;
  chk_endgame = check_win(pboard);
  if (chk_endgame == 1) {
     *leaf_val = (20 - depth);
  }
  else if (chk_endgame == -1) {
     *leaf_val = -(20 - depth);
  }
  else {
    chk_endgame = check_draw(pboard);
    if (chk_endgame) {
       *leaf_val = 0;
    }
  }
  return chk_endgame;
}

int chooseNextMove(int *position,char *pboard)
{
  int pos;
  int ret = 0;
  int currentpos =  *position;
   *position = 100;
  for (pos = currentpos; pos <= 4 * 4; pos++) {
    if ('_' == pboard[pos]) {
       *position = pos;
      ret = 1;
      break; 
    }
  }
  return ret;
}

int update_pos_weigh(int player,char *board)
{
  int minmaxpos = 1;
  int i;
  int ret;
  ret = chooseNextMove(&minmaxpos,board);
  if (!ret) {
    printf("\nPanic - cant choose next position*");
    return -1;
  }
  else {
//player 1
    if ((player % 2)) {
//check
      for (i = 1; i <= 4 * 4; i++) {
        if ((pos_weights[i] > pos_weights[minmaxpos]) && (board[i] == '_')) 
          minmaxpos = i;
      }
    }
    else 
//player 2
{
//check
      for (i = 1; i <= 4 * 4; i++) {
        if ((pos_weights[i] < pos_weights[minmaxpos]) && (board[i] == '_')) 
          minmaxpos = i;
      }
    }
  }
  return minmaxpos;
}
void minimax_block_bf(int depth,class _BlockStack *_stack,int _depth);
void minimax_block_df(int depth,class _BlockStack *_stack,int _depth,int pos);
void minimax(int player,char *board,int depth,int startpos);

void minimax_block_bf(int depth,class _BlockStack *_stack,int _depth)
{
  class _BlockSet *_set = _stack ->  get (_depth);
  class _Block *_block = _set -> block;
  class _Block *_nextBlock0 = &_set -> _BlockSet::nextBlock0;
  _nextBlock0 ->  recycle ();
  for (int _bi = 0; _bi < _block -> _Block::size; ++_bi) {
    class _Point &_point = _block ->  get (_bi);
    int player = _point._Point::player;
    char *board = _point._Point::board;
    int startpos = _point._Point::startpos;
    for (int pos = 1; pos <= 12; pos++) {{
        int eval_ended;
        int ret = 0;
        int leaf_val = 0;
        char *pboard = (char *)(__builtin_alloca((4 * 4 + 1) * sizeof(char )));
        int nplayer = 0;
        int nstartpos = startpos;
        if (depth == 0) {
          nstartpos = pos;
        }
        if (board[pos] != '_') 
          continue; 
        memcpy(pboard,board,(4 * 4 + 1));
        if (player == 2) {
          pboard[pos] = 'O';
          nplayer = 1;
        }
        else if (player == 1) {
          pboard[pos] = 'X';
          nplayer = 2;
        }
//Check if the game is over or depth of analysis is reached
        eval_ended = evaluationFunction(pboard,&leaf_val,depth,player);
        if (eval_ended) {
//Update the pos_weights array with the results
          if (leaf_val) {
            pos_weights[nstartpos] += leaf_val;
          }
          continue; 
        }
        _nextBlock0 ->  add (nplayer,pboard,nstartpos);
      }
    }
  }
  if (_nextBlock0 -> _Block::size > 0) {
    _stack ->  get (_depth + 1) -> _BlockSet::block = _nextBlock0;
    if (_nextBlock0 -> _Block::size <= _expandSize / _minBlockSize) {
      minimax_block_bf((depth + 1),_stack,_depth + 1);
    }
    else {
      for (int pos = 1; pos <= 12; pos++) {
        minimax_block_df((depth + 1),_stack,_depth + 1,pos);
      }
    }
  }
}

void minimax_block_df(int depth,class _BlockStack *_stack,int _depth,int pos)
{
  class _BlockSet *_set = _stack ->  get (_depth);
  class _Block *_block = _set -> block;
  class _Block *_nextBlock0 = &_set -> _BlockSet::nextBlock0;
  _nextBlock0 ->  recycle ();
  for (int _bi = 0; _bi < _block -> _Block::size; ++_bi) {
    class _Point &_point = _block ->  get (_bi);
    int player = _point._Point::player;
    char *board = _point._Point::board;
    int startpos = _point._Point::startpos;
{
{
        int eval_ended;
        int ret = 0;
        int leaf_val = 0;
        char *pboard = (char *)(__builtin_alloca((4 * 4 + 1) * sizeof(char )));
        int nplayer = 0;
        int nstartpos = startpos;
        if (depth == 0) {
          nstartpos = pos;
        }
        if (board[pos] != '_') 
          continue; 
        memcpy(pboard,board,(4 * 4 + 1));
        if (player == 2) {
          pboard[pos] = 'O';
          nplayer = 1;
        }
        else if (player == 1) {
          pboard[pos] = 'X';
          nplayer = 2;
        }
//Check if the game is over or depth of analysis is reached
        eval_ended = evaluationFunction(pboard,&leaf_val,depth,player);
        if (eval_ended) {
//Update the pos_weights array with the results
          if (leaf_val) {
            pos_weights[nstartpos] += leaf_val;
          }
          continue; 
        }
        _nextBlock0 ->  add (nplayer,pboard,nstartpos);
      }
    }
  }
  if (_nextBlock0 -> _Block::size > 0) {
    _stack ->  get (_depth + 1) -> _BlockSet::block = _nextBlock0;
    if (_nextBlock0 -> _Block::size <= _expandSize / _minBlockSize) {
      minimax_block_bf((depth + 1),_stack,_depth + 1);
    }
    else {
      for (int pos = 1; pos <= 12; pos++) {
        minimax_block_df((depth + 1),_stack,_depth + 1,pos);
      }
    }
  }
}

void minimax(int player,char *board,int depth,int startpos)
{
  for (int pos = 1; pos <= 12; pos++) {{
      int eval_ended;
      int ret = 0;
      int leaf_val = 0;
      char *pboard = (char *)(__builtin_alloca((4 * 4 + 1) * sizeof(char )));
      int nplayer = 0;
      int nstartpos = startpos;
      if (depth == 0) {
        nstartpos = pos;
      }
      if (board[pos] != '_') 
        continue; 
      memcpy(pboard,board,(4 * 4 + 1));
      if (player == 2) {
        pboard[pos] = 'O';
        nplayer = 1;
      }
      else if (player == 1) {
        pboard[pos] = 'X';
        nplayer = 2;
      }
//Check if the game is over or depth of analysis is reached
      eval_ended = evaluationFunction(pboard,&leaf_val,depth,player);
      if (eval_ended) {
//Update the pos_weights array with the results
        if (leaf_val) {
          pos_weights[nstartpos] += leaf_val;
        }
        continue; 
      }
      minimax(nplayer,pboard,(depth + 1),nstartpos);
    }
  }
}

int main(int argc,char **argv)
{
  int pos;
  int input;
  int player = 1;
  int chk = 0;
  int ret = 0;
  char *board = (char *)(__builtin_alloca((4 * 4 + 1) * sizeof(char )));
  init_board(board);
  print_board(board);
  if (argc < 2) {
    g_ncheck = 12;
    printf("Checking for 12-way, and block size is using default %d\n",_minBlockSize);
  }
  if (argc >= 2) 
    g_ncheck = atoi(argv[1]);
  _minBlockSize = g_ncheck;
  if (argc == 3) {
    _expandSize = atoi(argv[2]);
    printf("_expandSize: %d\n",_expandSize);
  }
  for (pos = 1; pos <= 4 * 4; pos++) 
//    for(pos = 1; pos <= 1; pos++)
{
    if (pos == 1) 
      input = 5;
    else 
      input = ret;
    if ((pos % 2) != 0) 
      board[input] = 'X';
    else 
      board[input] = 'O';
/*Print the board after each turn*/
    printf("\n****Board:********\n");
    print_board(board);
/*Check if game is over*/
    chk = check_win(board);
    if (chk == 1) {
      printf("Player X wins!\n");
      break; 
    }
    else if (chk == -1) {
      printf("Player O wins!\n");
      break; 
    }
    else 
/*Compute next best move*/
if ((chk == 0) && (pos != 4 * 4)) {
      memset(pos_weights,0,(sizeof(pos_weights)));
      player = (1 + (pos % 2));
      int l_player = player;
      int depth = 0;
      int startpos = 0;
      
#pragma recursionCallEntry
      _Block::max_block = _expandSize;
      class _BlockStack _stack;
      class _Block _block;
      _block. add (l_player,board,startpos);
      int _depth = 0;
      _stack. get (_depth) -> block = &_block;
      if (_block._Block::size <= _expandSize / _minBlockSize) {
        minimax_block_bf(depth,&_stack,_depth);
      }
      else {
        for (int pos = 1; pos <= 12; pos++) {
          minimax_block_df(depth,&_stack,_depth,pos);
        }
      }
      print_weights();
    }
    else {
      printf("The game is tied!\n");
    }
    ret = update_pos_weigh(player,board);
    if (-1 == ret) {
      return -1;
    }
    printf("\nOptimal move for player %d is %d",player,ret);
  }
  return 0;
}
