#include <vector>
#include <cassert>
using namespace std;

class _Point {
public:
	int l0;
	int r0;
	int l1;
	int r1;
	_Point() {}
	_Point(int l0, int r0, int l1, int r1);
};

_Point::_Point(int l0, int r0, int l1, int r1) {
	this->l0 = l0;
	this->r0 = r0;
	this->l1 = l1;
	this->r1 = r1;
}

class _Block {
public:
	_Block();
	~_Block();

	void add(int l0, int r0, int l1, int r1);
	_Point& get(int i) { return points[i]; }
	void recycle() { size = 0; }
	bool is_full() { return size == max_block; }
	bool is_empty() { return size == 0; }

	_Point* points;
	int size;

	static int root_n;
	static int* root_num;
	static int max_block;
};

class _BlockSet
{
public:
	_BlockSet() {}
	~_BlockSet() {}

	_Block *block;
	_Block nextBlock0;
};

class _BlockStack
{
public:
	_BlockStack() {}
	~_BlockStack();

	_BlockSet* get(int i);

	vector<_BlockSet *> items;
};

int _Block::max_block = 512;
int _Block::root_n;
int* _Block::root_num;

_Block::_Block() {
	points = new _Point[max_block];
	size = 0;
}

_Block::~_Block() {
	delete [] points;
}

void _Block::add(int l0, int r0, int l1, int r1) {
	assert(size < max_block);
	points[size].l0 = l0;
	points[size].r0 = r0;
	points[size].l1 = l1;
	points[size].r1 = r1;
	size++;
}


_BlockStack::~_BlockStack() {
	for (int i = 0; i < items.size(); i++) {
		delete items[i];
	}
}

_BlockSet* _BlockStack::get(int i) {
	while (i >= items.size()) {
		items.push_back(new _BlockSet());
	}
	return items[i];
}
