#include "block.h"
class _BlockStack ;
/**********************************************************/
/* This code is for PLDI-15 Artifact Evaluation only      */
/* and will be released with further copyright information*/
/* File: Basic sequential recursive version of parentheses*/
/**********************************************************/
#include <stdio.h>
#include <stdlib.h>
int _expandSize = 16;
int _minBlockSize = 16;
void parentheses_block_bf(int n,int *num,class _BlockStack *_stack,int _depth);
void parentheses_block_df0(int n,int *num,class _BlockStack *_stack,int _depth);
void parentheses_block_df1(int n,int *num,class _BlockStack *_stack,int _depth);
void parentheses(int l0,int r0,int l1,int r1,int n,int *num);

void parentheses_block_bf(int n,int *num,class _BlockStack *_stack,int _depth)
{
  class _BlockSet *_set = _stack ->  get (_depth);
  class _Block *_block = _set -> block;
  class _Block *_nextBlock0 = &_set -> _BlockSet::nextBlock0;
  _nextBlock0 ->  recycle ();
  for (int _bi = 0; _bi < _block -> _Block::size; ++_bi) {
    class _Point &_point = _block ->  get (_bi);
    int l0 = _point._Point::l0;
    int r0 = _point._Point::r0;
    int l1 = _point._Point::l1;
    int r1 = _point._Point::r1;
    if (l0 == n) {
       *num += 1;
    }
    else if (l0 < r0) {
    }
    else 
      _nextBlock0 ->  add ((l0 + 1),r0,l0,(r0 + 1));
    if (l1 == n) {
       *num += 1;
    }
    else if (l1 < r1) {
    }
    else 
      _nextBlock0 ->  add ((l1 + 1),r1,l1,(r1 + 1));
  }
  if (_nextBlock0 -> _Block::size > 0) {
    _stack ->  get (_depth + 1) -> _BlockSet::block = _nextBlock0;
    if (_nextBlock0 -> _Block::size <= _expandSize / _minBlockSize) {
      parentheses_block_bf(n,num,_stack,_depth + 1);
    }
    else {
      parentheses_block_df0(n,num,_stack,_depth + 1);
      parentheses_block_df1(n,num,_stack,_depth + 1);
    }
  }
}

void parentheses_block_df0(int n,int *num,class _BlockStack *_stack,int _depth)
{
  class _BlockSet *_set = _stack ->  get (_depth);
  class _Block *_block = _set -> block;
  class _Block *_nextBlock0 = &_set -> _BlockSet::nextBlock0;
  _nextBlock0 ->  recycle ();
  for (int _bi = 0; _bi < _block -> _Block::size; ++_bi) {
    class _Point &_point = _block ->  get (_bi);
    int l0 = _point._Point::l0;
    int r0 = _point._Point::r0;
    int l1 = _point._Point::l1;
    int r1 = _point._Point::r1;
    if (l0 == n) {
       *num += 1;
    }
    else if (l0 < r0) {
    }
    else 
      _nextBlock0 ->  add ((l0 + 1),r0,l0,(r0 + 1));
  }
  if (_nextBlock0 -> _Block::size > 0) {
    _stack ->  get (_depth + 1) -> _BlockSet::block = _nextBlock0;
    if (_nextBlock0 -> _Block::size <= _expandSize / _minBlockSize) {
      parentheses_block_bf(n,num,_stack,_depth + 1);
    }
    else {
      parentheses_block_df0(n,num,_stack,_depth + 1);
      parentheses_block_df1(n,num,_stack,_depth + 1);
    }
  }
}

void parentheses_block_df1(int n,int *num,class _BlockStack *_stack,int _depth)
{
  class _BlockSet *_set = _stack ->  get (_depth);
  class _Block *_block = _set -> block;
  class _Block *_nextBlock0 = &_set -> _BlockSet::nextBlock0;
  _nextBlock0 ->  recycle ();
  for (int _bi = 0; _bi < _block -> _Block::size; ++_bi) {
    class _Point &_point = _block ->  get (_bi);
    int l0 = _point._Point::l0;
    int r0 = _point._Point::r0;
    int l1 = _point._Point::l1;
    int r1 = _point._Point::r1;
    if (l1 == n) {
       *num += 1;
    }
    else if (l1 < r1) {
    }
    else 
      _nextBlock0 ->  add ((l1 + 1),r1,l1,(r1 + 1));
  }
  if (_nextBlock0 -> _Block::size > 0) {
    _stack ->  get (_depth + 1) -> _BlockSet::block = _nextBlock0;
    if (_nextBlock0 -> _Block::size <= _expandSize / _minBlockSize) {
      parentheses_block_bf(n,num,_stack,_depth + 1);
    }
    else {
      parentheses_block_df0(n,num,_stack,_depth + 1);
      parentheses_block_df1(n,num,_stack,_depth + 1);
    }
  }
}

void parentheses(int l0,int r0,int l1,int r1,int n,int *num)
{
  if (l0 == n) {
     *num += 1;
  }
  else if (l0 < r0) {
  }
  else {
    parentheses((l0 + 1),r0,l0,(r0 + 1),n,num);
  }
  if (l1 == n) {
     *num += 1;
  }
  else if (l1 < r1) {
  }
  else {
    parentheses((l1 + 1),r1,l1,(r1 + 1),n,num);
  }
}

int main(int argc,char **argv)
{
  if ((argc != 2) && (argc != 3)) {
    printf("Usage: parentheses [n]\n");
    exit(0);
  }
  int n = atoi(argv[1]);
  if (n < 1) {
    printf("Please input a larger number greater than 1\n");
    exit(0);
  }
  _minBlockSize = 2;
  printf("running parentheses %d\n",n);
  if (argc > 2) {
    _expandSize = atoi(argv[2]);
    printf("_expandSize is: %d\n",_expandSize);
  }
  int num = 0;
  int l0;
  int r0;
  int l1;
  int r1;
  l0 = 1;
  r0 = 0;
  l1 = 0;
  r1 = 1;
  
#pragma recursionCallEntry
  _Block::max_block = _expandSize;
  class _BlockStack _stack;
  class _Block _block;
  _block. add (l0,r0,l1,r1);
  int _depth = 0;
  _stack. get (_depth) -> block = &_block;
  if (_block._Block::size <= _expandSize / _minBlockSize) {
    parentheses_block_bf(n,&num,&_stack,_depth);
  }
  else {
    parentheses_block_df0(n,&num,&_stack,_depth);
    parentheses_block_df1(n,&num,&_stack,_depth);
  }
  printf("This is the result: %d\n",num);
  return 0;
}
