#include "block.h"
class _BlockStack ;
/**********************************************************/
/* This code is for PLDI-15 Artifact Evaluation only      */
/* and will be released with further copyright information*/
/* File: Basic sequential recursive version of nqueens   */
/**********************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
int _expandSize = 16;
int _minBlockSize = 16;

int ok(char n,char *a)
{
  for (int i = 0; i < n; i++) {
    char p = a[i];
    for (int j = (i + 1); j < n; j++) {
      char q = a[j];
      if (((q == p) || (q == (p - (j - i)))) || (q == (p + (j - i)))) 
        return 0;
    }
  }
  return 1;
}
void nqueens_block_bf(char n,char j,int *num,_BlockStack *_stack,int _depth);
void nqueens_block_df(char n,char j,int *num,_BlockStack *_stack,int _depth,int i);
void nqueens(char n,char j,char *a,int *num);
// pseudo tail recursive

void nqueens(char n,char j,char *a,int *num)
{
  for (int i = 0; i < n; i++) {{
      a[j] = i;
      if (!(ok((j + 1),a))) 
        continue; 
      if ((n - 1) == j) {
         *num += 1;
        continue; 
      }
      char *b = (char *)(__builtin_alloca((n * sizeof(char ))));
      memcpy(b,a,(n * sizeof(char )));
      nqueens(n,(j + 1),b,num);
    }
  }
}

int main(int argc,char **argv)
{
  if (argc < 2) {
    printf("number of queens required\n");
    return 1;
  }
  if (argc > 3) {
    printf("extra arguments being ignored\n");
    return 1;
  }
  int n = atoi(argv[1]);
  _minBlockSize = n;
  printf("running queens %d\n",n);
  if (argc > 2) {
    _expandSize = atoi(argv[2]);
    printf("_expandSize is: %d\n",_expandSize);
  }
  char *a = (char *)(__builtin_alloca((n * sizeof(char ))));
  int num = 0;
  
#pragma recursionCallEntry
  nqueens(n,0,a,&num);
  printf("nqueens = %d\n",num);
  return 0;
}
