#include <vector>
#include <cassert>
using namespace std;

struct state_t ;
struct sha1_ctx_s ;
struct node_t ;
class _Point {
public:
	node_t* parent;
	int numChildren;
	_Point() {}
	_Point(node_t* parent, int numChildren);
};

_Point::_Point(node_t* parent, int numChildren) {
	this->parent = parent;
	this->numChildren = numChildren;
}

class _Block {
public:
	_Block();
	~_Block();

	void add(node_t* parent, int numChildren);
	_Point& get(int i) { return points[i]; }
	void recycle() { size = 0; }
	bool is_full() { return size == max_block; }
	bool is_empty() { return size == 0; }

	_Point* points;
	int size;

	static int root_depth;
	static unsigned long long* root_subtreesize;
	static int max_block;
};

class _BlockSet
{
public:
	_BlockSet() {}
	~_BlockSet() {}

	_Block *block;
	_Block nextBlock0;
};

class _BlockStack
{
public:
	_BlockStack() {}
	~_BlockStack();

	_BlockSet* get(int i);

	vector<_BlockSet *> items;
};

int _Block::max_block = 512;
int _Block::root_depth;
unsigned long long* _Block::root_subtreesize;

_Block::_Block() {
	points = new _Point[max_block];
	size = 0;
}

_Block::~_Block() {
	delete [] points;
}

void _Block::add(node_t* parent, int numChildren) {
	assert(size < max_block);
	points[size].parent = parent;
	points[size].numChildren = numChildren;
	size++;
}


_BlockStack::~_BlockStack() {
	for (int i = 0; i < items.size(); i++) {
		delete items[i];
	}
}

_BlockSet* _BlockStack::get(int i) {
	while (i >= items.size()) {
		items.push_back(new _BlockSet());
	}
	return items[i];
}
