/*
SIMTree, a framework to automatically vectorize tree traversal algorithms.
Youngjoon Jo (yjo@purdue.edu)

Copyright 2013, School of Electrical and Computer Engineering, Purdue University.
 */

#ifndef BLOCKTRANSFORM_H_
#define BLOCKTRANSFORM_H_

#include "MethodInfo.h"

class BlockTransform {
public:
	static void transform(bool useSplice);
	static void addRecursivePrototype();
	static void findClasses();
private:

    static void setupFuncsyms();
	static void transformRecursive();
	static void transformRecursive_DF();
    static void generateRecursive_DF(SgFunctionDeclaration * BFFunc);
    static void generateRecursive_DF_i(SgFunctionDeclaration * BFFunc, int i);
	static void transformEntry();
	static void transformMapRootRecursive();
	static void transformMapRootIntermediary(const MethodInfo::IntermediaryInfo &minfo, bool last);
	static void transformMapRoot();

};

#endif /* BLOCKTRANSFORM_H_ */
