/*
SIMTree, a framework to automatically vectorize tree traversal algorithms.
Youngjoon Jo (yjo@purdue.edu)

Copyright 2013, School of Electrical and Computer Engineering, Purdue University.
 */

#ifndef COMMONTRANSFORM_H_
#define COMMONTRANSFORM_H_

#include <vector>
using namespace std;

#include "MethodInfo.h"

class CommonTransform {
public:
	static void transform();

	static void proEpilogueAnalysis(SgBasicBlock *block, SgStatement *divideStmt,
			vector<SgStatement *> &prologue, vector<SgStatement *> &epilogue,
			vector<SgVariableDeclaration *>& usedInEpilogueVarDecs);

	static void markAfterClassDecPragma();

	static void findRecursiveClassDefinition();

private:
	static void transformProEpilogue(const MethodInfo::IntermediaryInfo &minfo, bool last);
	static void transformProEpilogues();
};

#endif /* COMMONTRANSFORM_H_ */
