/*
SIMTree, a framework to automatically vectorize tree traversal algorithms.
Youngjoon Jo (yjo@purdue.edu)

Copyright 2013, School of Electrical and Computer Engineering, Purdue University.
 */

#include "rose.h"
#include "MethodInfo.h"
#include "RecursiveCallSet.h"
#include "Globals.h"

#include <vector>
using namespace std;

// command line params with defaults
bool g_useSplice = true;
bool g_useSOA = true;
bool g_useReexpand = true;
int g_spliceOptimizationLevel = Splice_NoOrder; // max opt level if not specified
int g_blockSize = 512;
int g_spliceDepth = 4;

SgFunctionDeclaration *g_recursiveFunction = NULL;
SgMemberFunctionDeclaration *g_recursiveMemberFunction = NULL;

vector<SgFunctionCallExp *> g_intermediaryCallSites;
vector<SgFunctionDeclaration *> g_intermediaryFunctions;
int g_numCallSites;
SgForStatement *g_enclosingForStmt = NULL;
SgForStatement *g_recursiveCallEnclosingForStmt = NULL; //For BF-DF toggling call code

int g_num_recursiveCall = 0;
vector<string> g_suffixBlock_DF_i;//[2] = {"_block_df0", "_block_df1"};

SgGlobal *g_global = NULL;

SgInitializedName *g_nodeParam;
int g_nodeParamIdx;
MethodInfo g_methodInfo;
vector<int> g_outerForLoopInvariantArgIdxs;
SgPragmaDeclaration *g_afterClassDecsPragma = NULL;



string g_recursiveTypeName;

SgPointerType *g_recursiveType = NULL;
SgNamedType *g_blockType;
SgNamedType *g_blockSetType;
SgNamedType *g_blockStackType;
SgNamedType *g_intermediaryBlockType;
SgNamedType *g_intermediaryStateType;
SgNamedType *g_pointType;

SgClassDeclaration *g_recursiveClassDec;
SgClassDeclaration *g_blockClassDec;
SgClassDeclaration *g_blockStackClassDec;
SgClassDeclaration *g_blockSetClassDec;
SgClassDeclaration *g_intermediaryStateClassDec;
SgClassDeclaration *g_intermediaryBlockClassDec;
SgClassDeclaration *g_pointClassDec;

SgMemberFunctionSymbol *g_interBlockResetSym;
SgMemberFunctionSymbol *g_interBlockNextSym;
SgMemberFunctionSymbol *g_blockStackGetSym;
SgMemberFunctionSymbol *g_blockGetSym;
SgMemberFunctionSymbol *g_blockAddSym;
SgMemberFunctionSymbol *g_blockRecycleSym;
SgMemberFunctionSymbol *g_blockCopyUpSym;
SgMemberFunctionSymbol *g_blockCopyBackSym;
SgMemberFunctionSymbol *g_spliceNodeAddSym;
