/*
SIMTree, a framework to automatically vectorize tree traversal algorithms.
Youngjoon Jo (yjo@purdue.edu)

Copyright 2013, School of Electrical and Computer Engineering, Purdue University.
 */

#ifndef INCLUDES_H_
#define INCLUDES_H_

#include <vector>
using namespace std;

typedef vector<int> IntVec;
typedef vector<SgVarRefExp *> ArgVec;
typedef vector<SgInitializedName *> ParamVec;
typedef vector<SgStatement *> StmtVec;

#define ConstIteratorFor(a, b, c) for (c::const_iterator a = (b).begin(); a != (b).end(); a++)
#define IteratorFor(a, b, c) for (c::iterator a = (b).begin(); a != (b).end(); a++)

#endif /* INCLUDES_H_ */
