/*
SIMTree, a framework to automatically vectorize tree traversal algorithms.
Youngjoon Jo (yjo@purdue.edu)

Copyright 2013, School of Electrical and Computer Engineering, Purdue University.
 */

#ifndef RECURSIVEFIELD_H_
#define RECURSIVEFIELD_H_

#include "rose.h"
#include <vector>
#include <set>
#include <string>
using namespace std;

class RecursiveCallSet;

class RecursiveField {
public:
	int id;
	string name;

	RecursiveField(string n) {
		name = n;
		id = recursiveFields.size();
	}

	// populate recursiveFields by looking through recursive call sites
	static void analyze(const RecursiveCallSet &rcs);


	static int getFieldId(string name);
	static int getFieldId(SgFunctionCallExp *call);

	static vector<RecursiveField> recursiveFields;
};

#endif /* RECURSIVEFIELD_H_ */
