/*
SIMTree, a framework to automatically vectorize tree traversal algorithms.
Youngjoon Jo (yjo@purdue.edu)

Copyright 2013, School of Electrical and Computer Engineering, Purdue University.
 */

#ifndef SPLICETRANSFORM_H_
#define SPLICETRANSFORM_H_

#include "MethodInfo.h"

class RecursiveCallSet;

class SpliceTransform {
public:
	static void transform();
	static void addRecursivePrototype();

	static void optimizationLevelAnalysis(const RecursiveCallSet& rcs);
private:
	static void transformEntry();
	static void transformRecursive();
	static void transformMapTree();
	static void transformMapTreeRecursive();
	static void transformMapTreeIntermediary(const MethodInfo::IntermediaryInfo &minfo, bool last);
	static void findSpliceClasses();
};

#endif /* SPLICETRANSFORM_H_ */
